/*
	NewMixCmd.h - set parameters for mixdown

	Will 18, 2001: will@opaline.demon.co.uk
*/

#ifndef NEWMIXCMD_H
#define NEWMIXCMD_H


#include "MixwaveUtils.h"
#include <NoUndoCmd.h>

#ifndef BREAK
#define BREAK
#include <BreakCmd.h>
#endif


class TextEdit;
class LineEdit;
class DMenuCmd;


class NewMixCmd : public NoUndoCmd
{
	protected:
		void doCommand();	// NewMix
		
	public:
		NewMixCmd ( char *, int );
		const char *const className() { return ( "NewMixCmd" ); }

	private:
		static void waveMenuSelectionCallback ( void *, unsigned int, char * );
		static void panMenuSelectionCallback ( void *, unsigned int, char * );
		static void gainMenuSelectionCallback ( void *, unsigned int, char * );
		// note 'ok' is mapped to 'enter' by TextEdit, LineEdit
		static void enterCallback ( void *, char * );
		static void cancelCallback ( void * );
		static void panEnteredCallback ( void *, char * );
		static void panCancelledCallback ( void * );
		static void gainEnteredCallback ( void *, char * );
		static void gainCancelledCallback ( void * );

		void waveSelected();
		void panSelected ( char * );
		void gainSelected ( char * );
		void setPan();
		void setGain();
		void setMix ( char *, int );
		void showMixData();

		const char *_name;
		unsigned int _arrayItems;	// num items on menu
		Boolean _menuRealised;
		Boolean _editRealised;
		Boolean _panMenuRealised;
		Boolean _gainMenuRealised;
		Boolean _gainEditRealised;
		Boolean _panEditRealised;
		unsigned int _waveNum;
		TextEdit *_edit;
		LineEdit *_gainEdit;
		LineEdit *_panEdit;
		DMenuCmd *_waveMenu;
		DMenuCmd *_panMenu;
		DMenuCmd *_gainMenu;
		MixwaveUtils *_utils;
};


#endif

